"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FrameViewer = FrameViewer;

var _react = _interopRequireWildcard(require("react"));

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _TableRenderer = require("./TableRenderer");

var _FancyRenderer = require("./FancyRenderer");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function FrameViewer(_ref) {
  var classframe = _ref.classframe,
      doc = _ref.doc,
      type = _ref.type,
      view = _ref.view,
      mode = _ref.mode,
      errors = _ref.errors,
      extract = _ref.extract,
      onExtract = _ref.onExtract,
      client = _ref.client;

  var _useState = (0, _react.useState)(),
      _useState2 = _slicedToArray(_useState, 2),
      docobj = _useState2[0],
      setDocObj = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = _slicedToArray(_useState3, 2),
      extractDocs = _useState4[0],
      setExtractDocs = _useState4[1];

  function ifExistsInExtractDocs(cls) {
    var find = [];
    extractDocs.map(function (item) {
      if (item.document.cls == cls) {
        find.push(item);
      }
    });
    return find;
  }

  function checkForClassChoices() {
    var properties = docobj.document.properties;

    for (var item in properties) {
      var store = [];

      if (properties[item].cframe.frame) {
        for (var i = 0; i < properties[item].values.length; i++) {
          if (!properties[item].values[i].isClassChoice()) {
            store.push(properties[item].values[i]);
          }
        }

        properties[item].values = store;
        var fr = properties[item].cframe.frame.operands;

        if (fr) {
          fr.map(function (cls) {
            var classFrame = ifExistsInExtractDocs(cls["class"]);

            if (classFrame.length) {
              classFrame.map(function (cf) {
                properties[item].values.push(cf.document);
              });
            }
          });
        }
      }
    }
  }

  (0, _react.useEffect)(function () {
    if (extract && onExtract && docobj) {
      checkForClassChoices();
      var ext = docobj.document.extract(); //console.log("ext", ext)

      onExtract(ext);
    }
  }, [extract]);
  (0, _react.useEffect)(function () {
    if (errors) {
      console.log("errors", errors);
    }
  }, [errors]);
  (0, _react.useEffect)(function () {
    if (classframe && view && mode == "edit") {
      var _docobj = view.create(client);

      if (classframe && classframe['system:properties']) {
        if (doc) {
          _docobj.load(classframe['system:properties'], doc);
        } else {
          _docobj.loadSchemaFrames(classframe['system:properties']);
        }

        _docobj.filterFrame();
      }

      setDocObj(_docobj);
      setExtractDocs(function (arr) {
        return [].concat(_toConsumableArray(arr), [_docobj]);
      });
    }

    if (classframe && view && mode == "view") {
      var _docobj2 = view.create(client);

      if (classframe && classframe['system:properties']) {
        if (doc) {
          _docobj2.load(classframe['system:properties'], doc);
        } else {
          _docobj2.loadSchemaFrames(classframe['system:properties']);
        }

        _docobj2.filterFrame();
      }

      setDocObj(_docobj2);
      setExtractDocs(function (arr) {
        return [].concat(_toConsumableArray(arr), [_docobj2]);
      });
    }
  }, [doc, view, classframe]);
  if (!docobj) return null;

  var docconf = _terminusdbClient["default"].View.document();

  docconf.all();

  if (type == "fancy") {
    return /*#__PURE__*/_react["default"].createElement(_FancyRenderer.FancyRenderer, {
      frame: docobj,
      mode: mode,
      view: view,
      errors: errors,
      client: client
    });
  } else {
    return /*#__PURE__*/_react["default"].createElement(_TableRenderer.TableRenderer, {
      frame: docobj,
      mode: mode,
      view: view,
      errors: errors,
      client: client,
      setExtractDocs: setExtractDocs,
      extractDocs: extractDocs
    });
  }
}