"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DataRenderer = exports.ChoiceRenderer = exports.FrameError = exports.FrameErrors = exports.DocumentRenderer = exports.ValueRenderer = exports.ChoiceClassRenderer = exports.PropertyRenderer = exports.TypeRenderer = exports.IDRenderer = exports.ObjectRenderer = exports.TableRenderer = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactBootstrap = require("react-bootstrap");

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

var _reactSelect = _interopRequireDefault(require("react-select"));

var _framesConstants = require("./frames.constants.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var TableRenderer = function TableRenderer(_ref) {
  var frame = _ref.frame,
      mode = _ref.mode,
      view = _ref.view,
      errors = _ref.errors,
      client = _ref.client,
      setExtractDocs = _ref.setExtractDocs,
      extractDocs = _ref.extractDocs;

  var _useState = (0, _react.useState)(0),
      _useState2 = _slicedToArray(_useState, 2),
      ping = _useState2[0],
      setPing = _useState2[1];

  (0, _react.useEffect)(function () {
    if (errors) {
      var frameconf = _terminusdbClient["default"].View.document();

      frame.setErrors(errors, frameconf);
      setPing(ping + 1);
    }
  }, [errors]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("table", {
    style: _framesConstants.TAB_STYLE
  }, /*#__PURE__*/_react["default"].createElement(ObjectRenderer, {
    frame: frame.document,
    mode: mode,
    view: view,
    ping: ping,
    client: client,
    setExtractDocs: setExtractDocs,
    extractDocs: extractDocs
  })));
};

exports.TableRenderer = TableRenderer;

var MissingPropertySelector = function MissingPropertySelector(_ref2) {
  var client = _ref2.client,
      frame = _ref2.frame,
      onAddProp = _ref2.onAddProp;
  var arr = [];

  if (frame.isObject() && frame.classframes) {
    if (frame.status == "new" || frame.newDoc) // for update of doc => display MissingProperty
      return /*#__PURE__*/_react["default"].createElement("div", null);
  }

  if (!frame.classframes) {
    var cls = frame.cls;

    if (client) {
      client.getClassFrame(cls).then(function (results) {
        var classframe = results;

        if (classframe && classframe['system:properties']) {
          for (var key in classframe['system:properties']) {
            arr.push({
              value: classframe['system:properties'][key].property,
              label: classframe['system:properties'][key].label["@value"],
              props: classframe['system:properties'][key]
            });
          }
        }
      });
      return /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], {
        onChange: onAddProp,
        options: arr,
        placeholder: "Add Property"
      });
    }
  } else {
    var mpl = frame.getMissingPropertyList();
    return /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], {
      onChange: onAddProp,
      options: mpl,
      placeholder: "Add Property"
    });
  }

  return /*#__PURE__*/_react["default"].createElement("div", null);
};

var ObjectRenderer = function ObjectRenderer(_ref3) {
  var frame = _ref3.frame,
      mode = _ref3.mode,
      view = _ref3.view,
      ping = _ref3.ping,
      setDocType = _ref3.setDocType,
      client = _ref3.client,
      setExtractDocs = _ref3.setExtractDocs,
      extractDocs = _ref3.extractDocs;
  if (!frame) return null;

  var _useState3 = (0, _react.useState)(1),
      _useState4 = _slicedToArray(_useState3, 2),
      redraw = _useState4[0],
      setRedraw = _useState4[1];

  var _useState5 = (0, _react.useState)(frame.subject()),
      _useState6 = _slicedToArray(_useState5, 2),
      oid = _useState6[0],
      setOid = _useState6[1];

  var _useState7 = (0, _react.useState)(frame.subjectClass()),
      _useState8 = _slicedToArray(_useState7, 2),
      otype = _useState8[0],
      setOtype = _useState8[1];

  var showid = view && view.show_id && frame.depth() == 0 ? view.show_id : false;
  var showtype = view && view.show_type ? view.show_type : false;

  var onAddProp = function onAddProp(e) {
    if (e.props) {
      var p = e.props;
    } else {
      var p = e.value;
    }

    frame.addProperty(p);
    setRedraw(redraw + 1);
  };

  var updateID = function updateID(nid) {
    frame.subjid = nid;
    setOid(nid);
  };

  var updateType = function updateType(ntype) {
    frame.cls = ntype;
    setOtype(ntype);
  };

  var renderProperties = function renderProperties() {
    var props = [];

    for (var p in frame.properties) {
      var pframe = frame.properties[p]; //if (pframe.cframe.isClassChoice())
      //    pframe.values=pframe.cframe

      var parentId = frame.subjid;
      props = props.concat( /*#__PURE__*/_react["default"].createElement(PropertyRenderer, {
        ping: ping,
        view: view,
        key: p + "_property",
        frame: pframe,
        mode: mode,
        client: client,
        setExtractDocs: setExtractDocs,
        extractDocs: extractDocs,
        parentId: parentId
      }));
    }

    return props;
  };

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("thead", null, /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("th", {
    colSpan: "2",
    style: _framesConstants.HEADER_STYLE,
    title: frame.subject()
  }, frame.subjectClass()), mode == "edit" && /*#__PURE__*/_react["default"].createElement("th", {
    style: _framesConstants.HEADER_STYLE
  }, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null, /*#__PURE__*/_react["default"].createElement(MissingPropertySelector, {
    client: client,
    frame: frame,
    onAddProp: onAddProp
  })), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null))))), /*#__PURE__*/_react["default"].createElement("tbody", null, showid && /*#__PURE__*/_react["default"].createElement(IDRenderer, {
    id: oid,
    mode: mode,
    view: view,
    update: updateID
  }), showtype && /*#__PURE__*/_react["default"].createElement(TypeRenderer, {
    type: otype,
    mode: mode,
    view: view,
    update: updateType
  }), renderProperties()));
};

exports.ObjectRenderer = ObjectRenderer;

var IDRenderer = function IDRenderer(_ref4) {
  var id = _ref4.id,
      mode = _ref4.mode,
      view = _ref4.view,
      update = _ref4.update;

  var onc = function onc(e) {
    update(e.target.value);
  };

  return /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("td", {
    style: _framesConstants.LABEL_STYLE
  }, "ID"), mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", null), /*#__PURE__*/_react["default"].createElement("td", {
    style: _framesConstants.VALUE_STYLE
  }, mode != "edit" && /*#__PURE__*/_react["default"].createElement("span", null, _terminusdbClient["default"].UTILS.shorten(id)), mode == "edit" && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null, /*#__PURE__*/_react["default"].createElement("input", {
    type: "text",
    value: _terminusdbClient["default"].UTILS.shorten(id),
    onChange: onc
  })), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null))));
};

exports.IDRenderer = IDRenderer;

var TypeRenderer = function TypeRenderer(_ref5) {
  var type = _ref5.type,
      mode = _ref5.mode,
      view = _ref5.view,
      update = _ref5.update;

  var onc = function onc(e) {
    update(e.target.value);
  };

  return /*#__PURE__*/_react["default"].createElement("tr", null, /*#__PURE__*/_react["default"].createElement("td", {
    style: _framesConstants.LABEL_STYLE
  }, "Type"), mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", null), /*#__PURE__*/_react["default"].createElement("td", {
    style: _framesConstants.VALUE_STYLE
  }, mode != "edit" && /*#__PURE__*/_react["default"].createElement("span", null, _terminusdbClient["default"].UTILS.shorten(type)), mode == "edit" && /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null, /*#__PURE__*/_react["default"].createElement("input", {
    type: "text",
    value: _terminusdbClient["default"].UTILS.shorten(type),
    onChange: onc
  })), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null))));
};

exports.TypeRenderer = TypeRenderer;

var PropertyRenderer = function PropertyRenderer(_ref6) {
  var frame = _ref6.frame,
      mode = _ref6.mode,
      view = _ref6.view,
      ping = _ref6.ping,
      client = _ref6.client,
      setExtractDocs = _ref6.setExtractDocs,
      extractDocs = _ref6.extractDocs,
      parentId = _ref6.parentId;
  if (!frame) return null;

  var _useState9 = (0, _react.useState)(1),
      _useState10 = _slicedToArray(_useState9, 2),
      redraw = _useState10[0],
      setRedraw = _useState10[1];

  var _useState11 = (0, _react.useState)(),
      _useState12 = _slicedToArray(_useState11, 2),
      rvals = _useState12[0],
      setRvals = _useState12[1];

  function addValueFrameForChoiceClass() {
    if (!frame.isClassChoice() || frame.values.length > 0) return;
    frame.addValueFrame(frame.createEmpty());
  }

  (0, _react.useEffect)(function () {
    if (mode == "edit") addValueFrameForChoiceClass();
    setRvals(getPvals());
  }, [frame, mode]);

  if (!frame.getLabel) {
    console.log("strange frame", frame);
    return null;
  }

  function getLabelPart(index, vframe) {
    return /*#__PURE__*/_react["default"].createElement("td", {
      key: frame.predicate + "_label",
      style: _framesConstants.LABEL_STYLE,
      rowSpan: 1
    }, mode == "edit" && /*#__PURE__*/_react["default"].createElement("button", {
      style: _framesConstants.PLUS_STYLE,
      onClick: getAddValue(index, vframe)
    }, "+"), frame.getLabel());
  }

  function getPvals() {
    var rvals = [];

    for (var i = 0; i < frame.values.length; i++) {
      rvals.push(frame.values[i]);
    }

    if (!frame.values.length) {
      rvals.push(frame.cframe);
    }

    return rvals;
  }

  var addValue = function addValue(vframe) {
    //console.log("add frame", frame)
    //console.log("parentId", parentId)
    frame.addValueFrame(frame.createEmpty());
    setRvals(getPvals());
    setRedraw(redraw + 1);
  };

  function getAddValue(index, vframe) {
    var g = vframe.get();

    var f = function f() {
      addValue(vframe, index);
    };

    return f;
  }

  var deleteValue = function deleteValue(val, index, extractDocs, setExtractDocs) {
    var newExtracts = [],
        newProps = [];

    for (var i = 0; i < rvals.length; i++) {
      if (rvals[i].subjid == val.subjid) {
        rvals[i].hide = true;

        if (val.status == "new") {
          //create
          for (var j = 0; j < extractDocs.length; j++) {
            if (extractDocs[j].document.subjid !== rvals[i].subjid) {
              newExtracts.push(extractDocs[j]);
            }
          }
        } else if (!val.newDoc) {
          //update
          for (var j = 0; j < extractDocs.length; j++) {
            for (var props in extractDocs[j].document.properties) {
              if (extractDocs[j].document.properties[props].isClassChoice()) {
                var pvals = extractDocs[j].document.properties[props].values;
                extractDocs[j].document.properties[props].values = [];

                for (var v = 0; v < pvals.length; v++) {
                  if (pvals[v].subjid !== rvals[i].subjid) {
                    //newExtracts.push(extractDocs[j])
                    extractDocs[j].document.properties[props].values.push(pvals[v]);
                    newExtracts.push(extractDocs[j]);
                  }
                }
              }
            }
          }
        }
      }
    }

    setExtractDocs(newExtracts);
    setRedraw(redraw + 1);
  };

  function getDelVal(index, vframe, extractDocs, setExtractDocs) {
    var g = vframe.get();

    var f = function f() {
      deleteValue(vframe, index, extractDocs, setExtractDocs);
    };

    return f;
  }

  if (!rvals || !rvals.length) return null; //console.log("rvals", rvals)

  var rows = [];

  for (var i = 0; i < rvals.length; i++) {
    if (rvals[i].hasOwnProperty('hide')) {
      if (rvals[i].hide) continue;
    }

    if (i == 0) {
      rows.push( /*#__PURE__*/_react["default"].createElement("tr", {
        key: frame.predicate + "_" + i
      }, getLabelPart(i, rvals[i]), mode == "edit" && /*#__PURE__*/_react["default"].createElement("td", {
        style: _framesConstants.DEL_STYLE
      }, /*#__PURE__*/_react["default"].createElement("button", {
        style: _framesConstants.MINUS_STYLE,
        onClick: getDelVal(i, rvals[i], extractDocs, setExtractDocs)
      }, "-"), " "), /*#__PURE__*/_react["default"].createElement("td", {
        key: frame.predicate + "_value_" + i,
        style: _framesConstants.VALUE_STYLE
      }, /*#__PURE__*/_react["default"].createElement(ValueRenderer, {
        redraw: redraw,
        frame: rvals[i],
        mode: mode,
        view: view,
        ping: ping,
        client: client,
        setExtractDocs: setExtractDocs
      }))));
    } else {
      rows.push( /*#__PURE__*/_react["default"].createElement("tr", {
        key: frame.predicate + "_" + i
      }, /*#__PURE__*/_react["default"].createElement("td", {
        style: _framesConstants.LABEL_STYLE,
        rowSpan: 1
      }), mode == "edit" && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("td", {
        style: _framesConstants.DEL_STYLE
      }, /*#__PURE__*/_react["default"].createElement("button", {
        style: _framesConstants.MINUS_STYLE,
        onClick: getDelVal(i, rvals[i], extractDocs, setExtractDocs)
      }, "-"))), /*#__PURE__*/_react["default"].createElement("td", {
        style: _framesConstants.VALUE_STYLE
      }, /*#__PURE__*/_react["default"].createElement(ValueRenderer, {
        redraw: redraw,
        frame: rvals[i],
        mode: mode,
        view: view,
        ping: ping,
        client: client,
        setExtractDocs: setExtractDocs
      }))));
    }
  }

  return rows;
};

exports.PropertyRenderer = PropertyRenderer;

var ChoiceClassRenderer = function ChoiceClassRenderer(_ref7) {
  var frame = _ref7.frame,
      mode = _ref7.mode,
      view = _ref7.view,
      redraw = _ref7.redraw,
      ping = _ref7.ping,
      client = _ref7.client,
      type = _ref7.type,
      updateVal = _ref7.updateVal,
      setExtractDocs = _ref7.setExtractDocs,
      extractDocs = _ref7.extractDocs;

  var _useState13 = (0, _react.useState)([]),
      _useState14 = _slicedToArray(_useState13, 2),
      opts = _useState14[0],
      setOpts = _useState14[1];

  var _useState15 = (0, _react.useState)([]),
      _useState16 = _slicedToArray(_useState15, 2),
      classOpts = _useState16[0],
      setClassOpts = _useState16[1];

  var _useState17 = (0, _react.useState)({}),
      _useState18 = _slicedToArray(_useState17, 2),
      selectedDoc = _useState18[0],
      setSelectedDoc = _useState18[1]; //console.log("redraw", redraw)
  //console.log("selectedDoc", selectedDoc)
  //console.log("frame", frame)


  (0, _react.useEffect)(function () {
    if (!client) return;
    var WOQL = _terminusdbClient["default"].WOQL;
    var range = frame.range;
    var q = WOQL.and(WOQL.lib().classes(), WOQL.sub(range, "v:Class ID").not().eq("v:Class ID", range));
    client.query(q).then(function (results) {
      for (var i = 0; i < results.bindings.length; i++) {
        opts.push({
          value: results.bindings[i]["Class ID"],
          label: results.bindings[i]["Class Name"]["@value"]
        });
      }

      setOpts(opts);
    })["catch"](function (err) {
      console.log("err", err);
    });
  }, [frame, client]);

  var onChange = function onChange(e) {
    if (!client || !e.value) return;
    var cls = e.value; //updateVal(cls)

    client.getClassFrame(cls).then(function (results) {
      var classframe = results;
      var docobj = view.create(client);

      if (classframe && classframe['system:properties']) {
        docobj.loadSchemaFrames(classframe['system:properties']);
        docobj.filterFrame();
        frame.subjid = docobj.document.subjid;
      }

      if (setExtractDocs) setExtractDocs(function (arr) {
        return [].concat(_toConsumableArray(arr), [docobj]);
      });
      setSelectedDoc(docobj);
    })["catch"](function (err) {
      console.log("err", err);
    });
  };

  (0, _react.useEffect)(function () {
    setClassOpts(opts);
  }, [opts]);
  (0, _react.useEffect)(function () {
    frame.selectedDoc = selectedDoc;
  }, [selectedDoc]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
    md: 6
  }, /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], {
    placeholder: "Choose a class",
    options: classOpts,
    onChange: onChange
  })), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, {
    md: 4
  }, type && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, _terminusdbClient["default"].UTILS.shorten(type)))), /*#__PURE__*/_react["default"].createElement(TableRenderer, {
    frame: selectedDoc,
    mode: mode,
    view: view,
    client: client,
    setExtractDocs: setExtractDocs,
    extractDocs: extractDocs
  }));
  /*return <>
      <Row>
          <Col md={6}>
              <Select placeholder="Choose a class"
                  options={classOpts}
                  onChange={handleClass}/>
          </Col>
          <Col md={4}>
              {type &&
                  <>{TerminusClient.UTILS.shorten(type)}</>
              }
          </Col>
      </Row>
      {selectedDoc.show && <TableRenderer frame={selectedDoc.docObj} mode={mode} view = {view} client={client} />}
  </> */
};

exports.ChoiceClassRenderer = ChoiceClassRenderer;

var ValueRenderer = function ValueRenderer(_ref8) {
  var frame = _ref8.frame,
      mode = _ref8.mode,
      view = _ref8.view,
      redraw = _ref8.redraw,
      ping = _ref8.ping,
      client = _ref8.client,
      setExtractDocs = _ref8.setExtractDocs,
      extractDocs = _ref8.extractDocs;

  var _useState19 = (0, _react.useState)(""),
      _useState20 = _slicedToArray(_useState19, 2),
      v = _useState20[0],
      setV = _useState20[1];

  (0, _react.useEffect)(function () {
    return setV(frame.get());
  }, [redraw, frame]);

  var updval = function updval(vv) {
    setV(vv);
    frame.set(vv);
  };

  if (!frame.isData()) {
    if (frame.isClassChoice()) {
      return /*#__PURE__*/_react["default"].createElement(ChoiceClassRenderer, {
        frame: frame,
        redraw: redraw,
        mode: mode,
        view: view,
        client: client,
        type: frame.getType(),
        updateVal: updval,
        setExtractDocs: setExtractDocs,
        extractDocs: extractDocs
      });
    } else {
      return /*#__PURE__*/_react["default"].createElement("table", {
        style: _framesConstants.TAB_STYLE
      }, /*#__PURE__*/_react["default"].createElement(ObjectRenderer, {
        frame: frame,
        mode: mode,
        view: view,
        client: client,
        setExtractDocs: setExtractDocs,
        extractDocs: extractDocs
      }));
    }
  } else if (frame.isChoice()) {
    return /*#__PURE__*/_react["default"].createElement(ChoiceRenderer, {
      val: v,
      frame: frame,
      mode: mode,
      updateVal: updval,
      view: view
    });
  } else if (frame.isDocument()) {
    return /*#__PURE__*/_react["default"].createElement(DocumentRenderer, {
      val: v,
      frame: frame,
      mode: mode,
      updateVal: updval,
      view: view
    });
  } else if (frame.isData()) {
    return /*#__PURE__*/_react["default"].createElement(DataRenderer, {
      frame: frame,
      val: v,
      type: frame.getType(),
      mode: mode,
      updateVal: updval,
      view: view
    });
  } else {
    console.log("Frame has no known type", frame);
  }
};

exports.ValueRenderer = ValueRenderer;

var DocumentRenderer = function DocumentRenderer(_ref9) {
  var val = _ref9.val,
      mode = _ref9.mode,
      frame = _ref9.frame,
      updateVal = _ref9.updateVal,
      view = _ref9.view;

  if (mode == "edit") {
    return /*#__PURE__*/_react["default"].createElement(DataRenderer, {
      frame: frame,
      val: val,
      mode: mode,
      type: frame.getType(),
      updateVal: updateVal
    });
  } else {
    var ds = function ds() {
      if (view.selectDocument) view.selectDocument(val);
    };

    var lstyle = {
      cursor: "pointer"
    };
    if (val === "") val = _terminusdbClient["default"].UTILS.shorten(frame.getType());
    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null, /*#__PURE__*/_react["default"].createElement("span", {
      style: lstyle,
      onClick: ds
    }, val)), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null));
  }
};

exports.DocumentRenderer = DocumentRenderer;

var FrameErrors = function FrameErrors(_ref10) {
  var frame = _ref10.frame,
      view = _ref10.view;

  if (!frame.errors) {
    return null;
  }

  var fes = [];

  for (var i = 0; i < frame.errors.length; i++) {
    fes.push( /*#__PURE__*/_react["default"].createElement(FrameError, {
      error: frame.errors[i]
    }));
  }

  return /*#__PURE__*/_react["default"].createElement("span", null, fes);
};

exports.FrameErrors = FrameErrors;

var FrameError = function FrameError(_ref11) {
  var error = _ref11.error;
  var msg = error && error['vio:message'] ? error['vio:message']["@value"] : error && error['api:message'] ? error['api:message'] : "Error with field";
  return /*#__PURE__*/_react["default"].createElement("span", {
    style: {
      color: "#f84848"
    }
  }, msg);
};

exports.FrameError = FrameError;

var ChoiceRenderer = function ChoiceRenderer(_ref12) {
  var val = _ref12.val,
      mode = _ref12.mode,
      frame = _ref12.frame,
      updateVal = _ref12.updateVal;

  if (mode == "edit") {
    var lab = val || "Select from choices";
    var opts = frame.frame.elements.map(function (item) {
      if (_terminusdbClient["default"].UTILS.compareIDs(item["class"], val)) {
        lab = item.label["@value"];
      }

      var className = _terminusdbClient["default"].UTILS.shorten(item["class"]);

      var label = item.label ? item.label["@value"] : className;
      return {
        value: className,
        label: label
      };
    });

    var onChange = function onChange(e) {
      updateVal(e.value);
    };

    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null, /*#__PURE__*/_react["default"].createElement(_reactSelect["default"], {
      defaultValue: val,
      isClearable: true,
      onChange: onChange,
      options: opts,
      placeholder: lab
    })), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null, frame.errors && /*#__PURE__*/_react["default"].createElement(FrameErrors, {
      frame: frame
    }), !frame.errors && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, _terminusdbClient["default"].UTILS.shorten(frame.range))));
  } else {
    var tit = val;
    var _lab = val;
    frame.frame.elements.map(function (item) {
      if (_terminusdbClient["default"].UTILS.compareIDs(item["class"], val)) {
        tit = val + (item.comment ? " - " + item.comment["@value"] : "");
        _lab = item.label ? item.label["@value"] : _terminusdbClient["default"].UTILS.labelFromURL(item["class"]);
      }
    });
    return /*#__PURE__*/_react["default"].createElement("span", {
      title: tit
    }, _lab);
  }
};

exports.ChoiceRenderer = ChoiceRenderer;

var DataRenderer = function DataRenderer(_ref13) {
  var val = _ref13.val,
      mode = _ref13.mode,
      type = _ref13.type,
      updateVal = _ref13.updateVal,
      frame = _ref13.frame;

  if (mode == "edit") {
    var onc = function onc(e) {
      updateVal(e.target.value);
    };

    var mv = val ? "" + val : "";
    return /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Row, null, /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null, /*#__PURE__*/_react["default"].createElement("input", {
      type: "text",
      value: mv,
      onChange: onc
    })), /*#__PURE__*/_react["default"].createElement(_reactBootstrap.Col, null, frame.errors && /*#__PURE__*/_react["default"].createElement(FrameErrors, {
      frame: frame
    }), !frame.errors && /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, _terminusdbClient["default"].UTILS.shorten(type))));
  } else {
    if (val !== "") return val;
    return _terminusdbClient["default"].UTILS.shorten(type);
  }
};

exports.DataRenderer = DataRenderer;