"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.modelCallServerHook = void 0;

var _react = _interopRequireWildcard(require("react"));

var _MainGraphObject = _interopRequireDefault(require("../MainGraphObject"));

var _terminusdbClient = _interopRequireDefault(require("@terminusdb/terminusdb-client"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var modelCallServerHook = function modelCallServerHook(woqlClient, branch, ref) {
  var _useState = (0, _react.useState)({
    classesResult: null,
    propsResult: null,
    restResult: null
  }),
      _useState2 = _slicedToArray(_useState, 2),
      mainGraphDataProvider = _useState2[0],
      setResultMainGraph = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      _useState4 = _slicedToArray(_useState3, 2),
      reloadGraph = _useState4[0],
      setReloadGraph = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      callServerLoading = _useState6[0],
      setLoading = _useState6[1];

  var _useState7 = (0, _react.useState)(false),
      _useState8 = _slicedToArray(_useState7, 2),
      reportMessage = _useState8[0],
      setReport = _useState8[1];
  /*
  * create the mainGraphObject and format the data
  */


  (0, _react.useEffect)(function () {
    var loadGraphData = function loadGraphData() {
      setLoading(true);

      var classQuery = _terminusdbClient["default"].WOQL.lib().classesAndChoices(); //const classesResult = await woqlClient.query(classQuery);


      var propsQuery = _terminusdbClient["default"].WOQL.lib().properties(); //const propsResult = await woqlClient.query(propsQuery);


      var restictions = _terminusdbClient["default"].WOQL.quad("v:Restriction", "type", "owl:Restriction", "schema/main").quad("v:Restriction", "owl:onProperty", "v:Property", "schema/main").and(_terminusdbClient["default"].WOQL.opt().quad("v:Restriction", "owl:cardinality", "v:cardinality", "schema/main"), _terminusdbClient["default"].WOQL.opt().quad("v:Restriction", "owl:maxCardinality", "v:max", "schema/main"), _terminusdbClient["default"].WOQL.opt().quad("v:Restriction", "owl:minCardinality", "v:min", "schema/main")); //const restResult = await woqlClient.query(restictions);


      Promise.all([woqlClient.query(classQuery), woqlClient.query(propsQuery), woqlClient.query(restictions)]).then(function (results) {
        setResultMainGraph({
          classesResult: results[0],
          propsResult: results[1],
          restResult: results[2]
        });
      })["catch"](function (err) {//setReport(err.message)
      })["finally"](function () {
        setLoading(false);
      });
    };

    if (woqlClient) loadGraphData(); //Promise.all([someCall(), anotherCall()]).then((results)=>{
  }, [reloadGraph, branch, ref]);

  var saveGraphChanges = function saveGraphChanges(query, commitMessage) {
    if (query !== undefined) {
      var ts = Date.now();
      setLoading(true);
      var commitM = commitMessage || "Update from model builder";
      woqlClient.query(query, commitM).then(function (result) {
        var msg = "Successfully updated schema graph";
        setReport({
          status: 'success',
          message: msg,
          time: Date.now() - ts
        });
        setReloadGraph(Date.now());
      })["catch"](function (err) {
        //setError(err.message)
        var rep = {
          status: 'error',
          error: err
        };
        var failureMessage = "Failed to load schema graph"; //setReport({failure: failureMessage, report: rep})

        setReport({
          status: "error",
          message: "Failed to update schema graph",
          error: err,
          time: Date.now() - ts
        });
      })["finally"](function () {
        setLoading(false);
      });
    }
  };

  var resetReport = function resetReport() {
    setReport(false);
  };

  return {
    mainGraphDataProvider: mainGraphDataProvider,
    saveGraphChanges: saveGraphChanges,
    reportMessage: reportMessage,
    callServerLoading: callServerLoading,
    resetReport: resetReport
  };
};

exports.modelCallServerHook = modelCallServerHook;